#ifndef HAPLINK_POSITION_H_
#define HAPLINK_POSITION_H_

#include "main.h"

//calibration values:
//#define OFFSET_NEGATIVE         150
//#define OFFSET_POSITIVE         3660 - OFFSET_NEGATIVE
#define OFFSET_NEGATIVE         160//0//120
#define OFFSET_POSITIVE         3855-OFFSET_NEGATIVE//4095//3921 - OFFSET_NEGATIVE
//#define FLIP_THRESHOLD          1000
#define FLIP_THRESHOLD          700

#define M_COUNTS_TO_RADIANS     0.00005544//0.00005414//0.00006496
//device values:
#define CX                      0.0       // center point x coordinate
#define CY                      0.0       // center point y coordinate
#define L_A                     87.0//83      //length of a linkage in mm
#define L_B                     100.0     //length of b linkage in mm
#define R_A                     75.0      // radius of Sector a in mm
#define R_B                     75.0      // radius of Sector b in mm
#define R_HA                    70.0        // radius of Handle A for Hapkit in mm
#define R_MA                    5.0//4.5       // radius of Motor a in mm
#define R_MB                    5.0//4.5       // radius of Motor b in mm
#define DELTATHETA_A            0.8727  //theta a offset in rad (50deg)
#define DELTATHETA_B            -1.4    //theta b offset in rad (-80deg)
#define THETA_B_OFFSET_RAD      ((THETA_B_OFFSET*3.1416)/180)   //the theta B offset you want to start with in radians

void updatePosition( void );
int getPosition1( void );
int getPosition2( void );
int initHaplinkPosition( void );
void calculatePositionHapkit( void );
void calculatePositionHandleAndJacobian( void );
double getRx( void );
double getRy( void) ;
double getThetaA( void );
double getThetaB( void );
double getThetaADeg( void );
double getThetaBDeg( void );
double getXH( void );
double getDxH( void );
double getDx( void );
double getDy( void );
double getTheta_ma( void );
double getTheta_mb( void );
double getTheta_maDeg( void );
double getTheta_mbDeg( void );

#endif
//EOF
