/**
  ******************************************************************************
  * @file    haplink_virtual_environments.cpp 
  * @author  melisao@stanford.edu
  * @version 1.0
  * @date    July-2017
  * @brief   Defines the functions to render virtual environments for Hapkit and
                Haplink.
  ******************************************************************************
  */
/* Includes ------------------------------------------------------------------*/
#include <math.h>
#include "main.h"
#include "haplink_position.h"
#include "haplink_pwm.h"
#include "haplink_virtual_environments.h"
#include "mbed.h"


/* Global Variables ----------------------------------------------------------*/
//variables needed declared in other files:
extern double J00, J01, J10, J11; //jacobian variables
extern double rx, ry, dx, dy; //position variables
extern double xH, dxH; //Hapkit position variables

//variables:
double TorqueX, TorqueY, ForceX, ForceY, TorqueMotor1, TorqueMotor2;

/*Debug Instantiations -------------------------------------------------------*/
//debug LED:
DigitalOut myled(LED1);

/* Function definitions ------------------------------------------------------*/
/*******************************************************************************
********** Debug LED ***********************************************************
*******************************************************************************/
void blinkLED( void )
{
   static uint32_t debugLEDCounter = 0;
   
   if (debugLEDCounter > 5000)
   {
        myled = !myled;
        debugLEDCounter = 0;
   } 
   else
   {
        debugLEDCounter = debugLEDCounter + 1;
    }
}

/*******************************************************************************
********** Hapkit Virtual Environments*****************************************
*******************************************************************************/
void hapkitRenderSpring( void )
{
}
void hapkitRenderVirtualWall( void )
{
}
void hapkitRenderLinearDamping( void )
{
}
void hapkitRenderTexture( void )
{
}
void hapkitRenderTexture2( void )
{
}

/*******************************************************************************
********** Haplink Virtual Environments*****************************************
*******************************************************************************/
void haplinkRenderInsideBox( void )
{
}
void haplinkRenderInsideCircle( void )
{
 }
void haplinkRenderOutsideCircle( void )
{
}
//EOF