#ifndef _HAPLINK_VIRTUAL_ENVIRONMENTS_H_
#define _HAPLINK_VIRTUAL_ENVIRONMENTS_H_

/* Virtual Environments Constants */

/* For Haplink */
//Constants for rendering being inside of a box
    #define K_WALL_X        500.0
    #define K_WALL_Y        500.0
    #define B_WALL          0.0//1.0
    //#define WALL_X1         -25.0 //position of Wall 1 in x in mm
    //#define WALL_X2         -5.0 //position of Wall 2 in x in mm
    //#define WALL_Y1         133.0 //position of Wall 1 in y in mm
    //#define WALL_Y2         153.0 //position of Wall 2 in y in mm
    #define WALL_X1         (26.0-5.0) //position of Wall 1 in x in mm
    #define WALL_X2         (26.0+5.0) //position of Wall 2 in x in mm
    #define WALL_Y1         (90.0-5.0) //position of Wall 1 in y in mm
    #define WALL_Y2         (90.0+5.0) //position of Wall 2 in y in mm
//Constants for rendering being inside of a circle
    #define KCircle         300.0 
    #define BCircle         0.0
    #define RCircle         3.0 //Radius of the circle in mm
    //#define CCircleX        -16.0 //x coordinate of the center point of the circle in mm
    //#define CCircleY        140.0 // y coordinate of the center point of the circle in mm
    #define CCircleX        26.0 //x coordinate of the center point of the circle in mm
    #define CCircleY        90.0 // y coordinate of the center point of the circle in mm
//Constants for rendering being outside of a circle
    #define KCircle2         500.0 
    #define BCircle2         0.0
    #define RCircle2         30.0 //Radius of the circle in mm
    //#define CCircleX2        -5.0 //x coordinate of the center point of the circle in mm
    //#define CCircleY2        120.0 // y coordinate of the center point of the circle in mm  
    #define CCircleX2        (26.0-35.0) //x coordinate of the center point of the circle in mm
    #define CCircleY2        (90.0) // y coordinate of the center point of the circle in mm    
    
/* For Hapkit */
//Constant for rendering a Spring  
    #define K_SPRING        100.0           //Spring constant in N/m
//Constant for rendering linear damping
    #define B_LINEAR        10000.0            //Linear damping in N*s/m
//Constants for virtual wall
    #define X_WALL          5.0             //Position of the virtual wall in mm
    #define K_WALL          500.0           //Maximum stiffness of the virtual Wall in N/m
//Constants for nonlinear damping
    #define B_NONLINEAR     15.0            //Nonlinear damping in N*s/m
    #define DXH_THRESHOLD   50.0            //Velocity threshold in mm/s
    #define B_SCALING       2000.0          //Scaling of the nonlinear damping
//Constants for Texture
    #define TEXTURE_SPATIAL_FREQUENCY 200.0 //Spatial Frequency of texture rendering
    #define TEXTURE_DAMPING           1000.0   //Damping for texture rendering
//Constants for Texture 2
    #define TEXTURE_SPATIAL_FREQUENCY_2 10.0 //Spatial Frequency of texture rendering
    #define TEXTURE_K_2           500.0      //Stiffness for texture rendering
        

/* Virtual Environments Functions*/
//debug
void blinkLED( void );
//Hapkit
void hapkitRenderSpring( void );
void hapkitRenderVirtualWall( void );
void hapkitRenderLinearDamping( void );
void hapkitRenderTexture( void );
void hapkitRenderTexture2( void );

//Haplink
void haplinkRenderInsideBox( void );
void haplinkRenderInsideCircle( void );
void haplinkRenderOutsideCircle( void );

#endif